#id=y[,2] time=y[,4] logeRna50=y[,10] stcd4=y[,12] 

####### r=y[,13]


#h(t)=h0(t)exp(r1*Z+r2*b1+r3*b2+r4*b3)


#Begin of model
model
{
  for (i in 1:m) 
  {
    #parametric random effects of normal-Response model
    b2[i,1]<-0
    b2[i,2]<-0
    b2[i,3]<-0
    b2[i,4]<-0
    b2[i,5]<-0
    b2[i,6]<-0
    ###   b2[i,4]<-0
    b[i,1:6]~dmnorm(b2[i,1:6], Omega2[,])
    
    #parametric random effects of survival model
 #   b.surv2[i,1]<-0
#    b.surv2[i,2]<-0
 #   b.surv2[i,3]<-0
    ###   b2[i,4]<-0
  #  b.surv[i,1:3]~dmnorm(b.surv2[i,1:3], Omega2b[,])
    

    
    #parametric random effects of normal--Covariate model
#    a3[i,1]<-0
#    a3[i,2]<-0
#    a3[i,3]<-0
#    a[i,1:3]~dmnorm(a3[i,1:3], Omega3[,])
#    L48[i]<-beta[2]+b[i,2]
  }
  
  
  
  
  ##Time to event model
  #Set up data
  for(i in 1:m)
  {
    for(j in 1:T)
    {
      #risk set = 1 if obs.t >= t
      risk[i,j]<-step(obs.t[i]-t[j]+eps) 
      #counting process jump = 1 if obs.t in [t[j], t[j+1])
      #    i.e.if t[j]<=obs.t<t[j+1]
      dN[i,j]<-risk[i,j]*step(t[j+1]-obs.t[i]-eps)*fail[i]
      dN2[i,j]<-risk[i,j]*step(t[j+1]-obs.t[i]-eps)*fail2[i] ## competing risk
    }
  }
  
  #Model
  for(j in 1:T)
  {
    for (i in 1:m)
    {
      
      dN[i,j] ~ dpois(ldt[i,j]) 
      dN2[i,j] ~ dpois(ldt2[i,j]) 
   
      fix.surv[i,j] <- gamma[1]* cd4.basis[ (i * 48 - 48 + j) , 1 ]  + gamma[2]* cd4.basis[ (i * 48 - 48 + j) , 2 ]  + gamma[3]* cd4.basis[ (i * 48 - 48 + j) , 3 ] # Likehood
      ran.surv[i,j] <- b[ i,4 ]* cd4.basis[ (i * 48 - 48 + j) , 1 ]  + b[ i,5 ]* cd4.basis[ (i * 48 - 48 + j) , 2 ]  + b[ i,6 ]* cd4.basis[ (i * 48 - 48 + j) , 3 ]
      ldt[i,j] <- risk[i,j]*exp( fix.surv[i,j] + ran.surv[i,j] )*dL0[j] #Intensity
      
     fix.surv2[i,j]  <- gamma2[1]* cd4.basis[ ( i * 48 - 48 + j) , 1 ]  + gamma2[2]* cd4.basis[ ( i * 48 - 48 + j) , 2 ]  + gamma2[3]* cd4.basis[ ( i * 48 - 48 + j) , 3 ] # Likehood
      ran.surv2[i,j]  <- scale[1] * b[ i,4 ]* cd4.basis[ ( i * 48 - 48 + j) , 1 ]  + scale[2] * b[ i,5 ]* cd4.basis[ ( i * 48 - 48 + j) , 2 ]  +  scale[3] * b[ i,6 ]* cd4.basis[ ( i * 48 - 48 + j) , 3 ]
      ldt2[i,j] <- risk[i,j]*exp( fix.surv2[i,j] + ran.surv2[i,j] )*dL02[j] #Intensity
    }
    dL0[j]~ dgamma(mu0[j],c)
    mu0[j] <- dL0.star[j]*c   #prior mean hazard
    dL02[j]~ dgamma(mu02[j],c2)
    mu02[j] <- dL02.star[j]*c2   #prior mean hazard
  }
  #coefficients
  c<- 1 ##0.01
  r<- 1
  for (j in 1:T) {dL0.star[j]<-r*(t[j+1]-t[j])}
  c2<- 1 ##0.01
  r2<- 1
  for (j in 1:T) {dL02.star[j]<-r2*(t[j+1]-t[j])}
  
  
  #### competing risk non-HIV caused death #####
  
  
  
  
  
  
  for (j in 1:N)  #N=total number of measurements=530
  {
    ###modelling nonignorable missingness model
##    logit(mu.r[j])<-psi[1]+psi[2]*y[j,10]+psi[3]*y[j,12]
    
    #y[j,12]=standardized cd4 and y[j,10]=ln(rna50)
    #######  mu.r2[j]<-max(0.001,min(mu.r[j],0.999))
    #######  y[j,13] ~ dbern(mu.r2[j])  # y[j,13]=indicator 0 or 1 (1=missinf, 0=observed)
    
    
    
    ## CD4 covariate model with measurement errors
    #######    w2[j] ~ dt(0,1,nu2)I(0,)
    #######    c2[j] <-(nu2+w2[j]*w2[j])/n2
    #######    aau2[j]<-tau2/c2[j]
##    z.star[j] <- (alpha[1]+a[y[j,2],1])+(alpha[2]+a[y[j,2],2])*y[j,4]+(alpha[3]+a[y[j,2],3])*y[j,4]*y[j,4]
    #######  z.mean[j]<- z.star[j]+delta2*(w2[j]-mue2)   #ST distribution
    #######        #z.mean[j]<- z.star[j]      #normal distribution
    #######         y[j,12] ~ dt(z.mean[j],aau2[j],n2)   #y[j,12] standardized cd4
    
    ### Varying coef Mixed-effects Model with ST distribution
    ## design matrix
    zb[ j, 1 ] <- y2[ j, 24 ] * y2[ j, 27  ]  ## cd4std * basis 1; DO NOT USE y[ j,  6 ] USE z.mean[j] INSTEAD
    zb[ j, 2 ] <- y2[ j, 24 ]  * y2[ j, 28 ]  ## cd4std * basis 2    
    zb[ j, 3 ] <- y2[ j, 24 ]  * y2[ j, 29  ]  ## cd4std * basis 3
    
    fix[ j ] <- y2[j, 27]  * beta[1] + y2[j, 28]  * beta[2] + y2[j, 29]  * beta[3] + zb[j, 1]  * beta[4] + zb[j, 2]  * beta[5] + zb[j, 3]  * beta[6] 
    ran[ j ] <- zb[j, 1]  * b[y2[j,23],1] + zb[j, 2]  * b[y2[j,23],2] + zb[j, 3]  * b[y2[j,23],3]
    
    dm5[j] <- fix[ j ]+ ran[ j ]
    
      w[j]~dt(0,1,nu)I(0,)
      c1[j]<-(nu+w[j]*w[j])/n1
      aau[j]<-tau * c1[j] 
     mu[j]<- dm5[j] +delta*(w[j]-mue)   #ST distribution
    ##mu[j]<- dm5[j]                    #normal distribution
      y2[j,25]~dt(mu[j],aau[j],n1)           #y[,13]=logerna50
      Y.pred[j]~dt(mu[j],aau[j],n1)           #predict value
    
    ##y2[ j, 25 ] ~ dnorm(mu[j], tau)  
    ##Y.pred[j] ~ dnorm(mu[j], tau) 

    
    ###modelling nonignorable missingness model for response
    logit(mu.r[j])<-psi[1]+psi[2] * y2[j,25]  ###y[j,6]
    
    #y[j,12]=standardized cd4 and y[j,10]=ln(rna50)
    mu.r2[j]<-max(0.001,min(mu.r[j],0.999))
    y2[j,26] ~ dbern(mu.r2[j])  # y[j,10]=indicator 0 or 1 (1=missinf, 0=observed) for CD4
    
    
    
    ## Fitted values and Residuals
    fit[j]<-mu[j]
    resid[j]<-y2[j,25]-fit[j]
    ##sresid[j]<-sqrt(tau)*(y[j,13]-fit[j])*sqrt(1-2/nu)
    ssr[j]<-pow(resid[j],2)      #squares of residuals
    ##  ssr.r[j]<-pow(sresid[j],2)     #squares of standardized residuals
    ssr.p[j]<-pow((Y.pred[j]-y2[j,25]),2)    #deviance of predicted value from observed
  }
  
  
  
  
  SSR<-sum(ssr[])      #sum of squares of residuals
###  SSRr<-sum(ssr.r[])   #sum of squares of standardized residuals
  SSRp<-sum(ssr.p[])   #EPD
  
  
  
  #(0)Degree of freedom
    nu0<-0.5
    nu~ dexp(nu0)I(3,)
    n1<-nu+1
    mue<-exp(loggam(0.5*(nu-1))-loggam(0.5*nu))*sqrt(nu/3.14159)
  
  ## nu20<-0.5
  ##  nu2~ dexp(nu20)I(3,)
  ##  n2<-nu2+1
  ##  mue2<-exp(loggam(0.5*(nu2-1))-loggam(0.5*nu2))*sqrt(nu2/3.14159)
  
  #(1) Coefficients
  for (l in 1:6){beta[l]~dnorm(0,1.0E-2)}
  ##  for (k in 1:3){alpha[k]~dnorm(0,1.0E-2)}
    for (l in 1:3){gamma[l]~dnorm(0,1.0E-2)}
  for (l in 1:3){gamma2[l]~dnorm(0,1.0E-2)}
  for (l in 1:3){scale[l]~dnorm(0,1.0E-2)}  ## scale parameter in competing risk model
  for (l in 1:2){psi[l]~dnorm(0,1.0E-2)}
  
  #(2) Skew-normal random effects
   delta ~ dnorm(0.0, 0.01)
  #  delta2 ~ dnorm(0.0, 0.01)
  
  
  
  #(3) Variance-covariance matrice
  Omega2[1:6,1:6] ~ dwish(R2[,],6)
  V2[1:6,1:6]<-inverse(Omega2[,])
  
#  Omega2b[1:3,1:3] ~ dwish(R2b[,],3)
#  V2b[1:3,1:3]<-inverse(Omega2b[,])
  
  #  Omega3[1:3,1:3] ~ dwish(R3[,],3)
  #  V3[1:3,1:3]<-inverse(Omega3[,])
  
  #(4) Precision parameters
  tau ~ dgamma(.01,.01)
  sigma.tau <- 1/tau
  #  tau2 ~ dgamma(.01,.01)
  #  sigma.tau2 <- 1/tau2
  # tau3 ~ dgamma(0.01,0.01)
  # sigma.tau3 <- 1/tau3
  # tau4 ~ dgamma(0.01,0.01)
  # sigma.tau4 <- 1/tau4
}
##End of model





#Initial values
##list(dL0=c(5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0), gamma=c(0.01,0.01,0.041,-0.012,0.001),
##     beta=c(11.72,65.7,7.3,4.2,0.9),
##     alpha=c(-0.45,2.18,0.01),
##     psi=c(0.1,0.1,0.1),
##     nu=5, nu2=5,
##     delta=1.5, delta2=0.5, tau=1, tau2=1,
##     Omega2=structure(
##       .Data=c(1.229, .043, -.750, .170,
##               .043,.090, .002,-.013,
##               -.750,-.002,1.059,-.214,
##               .170,-.013,-.214,.120), .Dim=c(4,4)),
##     Omega3=structure(
##       .Data=c(.1,0,0
##               0,.1,0
##               0,0,.1), .Dim=c(3,3)))


##list(dL0=c(4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0), gamma=c(0.01,0.01,0.041,-0.012,0.001),
##     beta=c(12.72,66.7,87.3,5.2,1.9),
##     alpha=c(-0.45,2.18,0.01),
##     psi=c(0.1,0.1,0.1),
##     nu=5, nu2=5,
##     delta=1.5, delta2=0.5, tau=1, tau2=1,
##     Omega2=structure(
##       .Data=c(1.229, .043, -.750, .170,
##               .043,.090, .002,-.013,
##               -.750,-.002,1.059,-.214,
##               .170,-.013,-.214,.120), .Dim=c(4,4)),
##     Omega3=structure(
##       .Data=c(.1,0,0
##               0,.1,0
##               0,0,.1), .Dim=c(3,3)))


##list(dL0=c(3.0,3.0,3.0,3.0,3.0,3.0,3.0,3.0,3.0,3.0), gamma=c(0.01,0.01,0.041,-0.012,0.001),
##     beta=c(10.72,64.7,85.3,3.2,0.9),
##     alpha=c(-0.45,2.18,0.01),
##     psi=c(0.1,0.1,0.1),
##     nu=5, nu2=5,
##     delta=1.5, delta2=0.5, tau=1, tau2=1,
##     Omega2=structure(
##       .Data=c(1.229, .043, -.750, .170,
##               .043,.090, .002,-.013,
##               -.750,-.002,1.059,-.214,
##               .170,-.013,-.214,.120), .Dim=c(4,4)),
##     Omega3=structure(
##       .Data=c(.1,0,0
##               0,.1,0
##               0,0,.1), .Dim=c(3,3)))

#End of program

